%define anolis_release 1

%undefine _package_note_flags
%ifnarch %{ocaml_native_compiler}
%global debug_package %{nil}
%endif

Name:           ocaml-result
Version:        1.5
Release:        %{anolis_release}%{?dist}
Summary:        Compat result type

%global libname %(echo %{name} | sed -e 's/^ocaml-//')

License:        BSD
URL:            https://github.com/janestreet/result/
Source0:        %{URL}/archive/%{version}/%{name}-%{version}.tar.gz

BuildRequires:  ocaml
BuildRequires:  ocaml-dune >= 1.0

%description
Projects that want to use the new result type defined in
OCaml >= 4.03 while staying compatible with older versions
of OCaml should use the Result module defined in this library.

%package        devel
Summary:        Development files for %{name}
Requires:       %{name} = %{version}-%{release}

%description    devel
The %{name}-devel package contains libraries and signature
files for developing applications that use %{name}.

%package        doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{libname}-%{version}

%build
dune build %{?_smp_mflags}

%install
dune install --destdir=%{buildroot}

# We install the documentation with the doc macro
rm -fr %{buildroot}%{_prefix}/doc

%ifarch %{ocaml_native_compiler}
# Add missing executable bits
find %{buildroot}%{_libdir}/ocaml -name \*.cmxs -exec chmod a+x {} \+
%endif

%generate_compatibility_deps

%check
dune runtest

%files
%license LICENSE.md
%dir %{_libdir}/ocaml/%{libname}/
%{_libdir}/ocaml/%{libname}/META
%{_libdir}/ocaml/%{libname}/%{libname}.cma
%{_libdir}/ocaml/%{libname}/%{libname}.cmi
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{libname}/%{libname}.cmxs
%endif

%files devel
%license LICENSE.md
%ifarch %{ocaml_native_compiler}
%{_libdir}/ocaml/%{libname}/%{libname}.a
%{_libdir}/ocaml/%{libname}/%{libname}.cmxa
%{_libdir}/ocaml/%{libname}/%{libname}.cmx
%endif
%{_libdir}/ocaml/%{libname}/%{libname}.ml
%{_libdir}/ocaml/%{libname}/%{libname}.cmt
%{_libdir}/ocaml/%{libname}/dune-package
%{_libdir}/ocaml/%{libname}/opam

%files doc
%doc CHANGES.md README.md

%changelog
* Thu Mar 23 2023 Yuanhong Peng <yummypeng@linux.alibaba.com> - 1.5-1
- Init from upstream
